/******************************************************************************
 * @file		main.c
 * @brief		  
 * @version		v1.0
 * @date		11  2015
 *
 * @note
 *  " " (http://motorcontrol.ru),   .
 *
 * @par
 *  " "      
 * ,     .
 *
 * @par
 *     " ",  ,
 *  ,     ,    .
 *  " "       ,
 *    .
 *
 ******************************************************************************/

//     Keil    ,
//      http://forum.niiet.ru/viewtopic.php?f=37&t=486

//        .
//         .
//     ,   ,    TimerPeriod,
//       6 .
//  " "     .

#include "main.h"


//  /    ControlCARD
//    NT_GPIOC->DATA &= ~(1 << 2)  NT_GPIOC->DATA |= (1 << 2), 
//      ,   2  (   ), , 
//  2 ,  NT_GPIOC->DATA &= ~(1 << 2)  NT_GPIOC->DATA &= ~(1 << 3),  
//    ,          ,  
//    .    GPIO    ,       (  )
//     ,    ,      ,
//    .
//         .    
//       GPIO    .

//  -   GPIO   (. ): MASKLOWBYTE -    , MASKHIGHBYTE -  .
//,    "1"  GPIO2, GPIO3  GPIO4  C:
//0001 1100		,     MASKLOWBYTE
//xxx1 11xx		 :    - ,   -  , ..         
//NT_GPIOC->MASKLOWBYTE[28].MASKLOWBYTE_b.MASKLB = 28;	   ,  : NT_GPIOC->MASKLOWBYTE[28].MASKLOWBYTE_b.MASKLB = 0xFF;
//   GPIO2  GPIO4   GPIO3, :
//NT_GPIOC->MASKLOWBYTE[28].MASKLOWBYTE_b.MASKLB = 20;	20 = 0001 0100b
//      ,   ,     ,   .
//           ,   .

#define VD1_ON NT_GPIOC->MASKLOWBYTE[4].MASKLOWBYTE_b.MASKLB = 0			//NT_GPIOC->DATA &= ~(1 << 2)
#define VD1_OFF NT_GPIOC->MASKLOWBYTE[4].MASKLOWBYTE_b.MASKLB = 4			//NT_GPIOC->DATA |= (1 << 2)

#define VD2_ON NT_GPIOC->MASKLOWBYTE[8].MASKLOWBYTE_b.MASKLB = 0			//NT_GPIOC->DATA &= ~(1 << 3)
#define VD2_OFF NT_GPIOC->MASKLOWBYTE[8].MASKLOWBYTE_b.MASKLB = 8			//NT_GPIOC->DATA |= (1 << 3)

#define VD3_ON NT_GPIOB->MASKLOWBYTE[32].MASKLOWBYTE_b.MASKLB = 0			//NT_GPIOB->DATA &= ~(1 << 5)
#define VD3_OFF NT_GPIOB->MASKLOWBYTE[32].MASKLOWBYTE_b.MASKLB = 32		//NT_GPIOB->DATA |= (1 << 5)

#define VD4_ON NT_GPIOB->MASKLOWBYTE[64].MASKLOWBYTE_b.MASKLB = 0			//NT_GPIOB->DATA &= ~(1 << 6)
#define VD4_OFF NT_GPIOB->MASKLOWBYTE[64].MASKLOWBYTE_b.MASKLB = 64		//NT_GPIOB->DATA |= (1 << 6)

#define VD5_ON NT_GPIOB->MASKLOWBYTE[128].MASKLOWBYTE_b.MASKLB = 0		//NT_GPIOB->DATA &= ~(1 << 7)
#define VD5_OFF NT_GPIOB->MASKLOWBYTE[128].MASKLOWBYTE_b.MASKLB = 128		//NT_GPIOB->DATA |= (1 << 7)

#define VD6_ON NT_GPIOB->MASKHIGHBYTE[1].MASKHIGHBYTE_b.MASKHB = 0			//NT_GPIOB->DATA &= ~(1 << 8)
#define VD6_OFF NT_GPIOB->MASKHIGHBYTE[1].MASKHIGHBYTE_b.MASKHB = 1		//NT_GPIOB->DATA |= (1 << 8)

//     (         )
int TimerPeriod = 500000;


//       
void LED_init (void)
{
	//    :
	//1)             .
	//     "1"     ALTFUNCCLR (CLR - clear - ).
	//    ,    "1"     ALTFUNCSET (SET - ).
	//      ,      ALTFUNCCLR  ALTFUNCSET.
	//2)       "1"     OUTENSET.
	NT_GPIOC->ALTFUNCCLR_b.ALTFUNCCLR = (1 << 2);
	NT_GPIOC->OUTENSET_b.OUTENSET |= (1 << 2);
	NT_GPIOC->ALTFUNCCLR_b.ALTFUNCCLR = (1 << 3);
	NT_GPIOC->OUTENSET_b.OUTENSET |= (1 << 3);
	NT_GPIOB->ALTFUNCCLR_b.ALTFUNCCLR = (1 << 5);
	NT_GPIOB->OUTENSET_b.OUTENSET |= (1 << 5);
	NT_GPIOB->ALTFUNCCLR_b.ALTFUNCCLR = (1 << 6);
	NT_GPIOB->OUTENSET_b.OUTENSET |= (1 << 6);
	NT_GPIOB->ALTFUNCCLR_b.ALTFUNCCLR = (1 << 7);
	NT_GPIOB->OUTENSET_b.OUTENSET |= (1 << 7);
	NT_GPIOB->ALTFUNCCLR_b.ALTFUNCCLR = (1 << 8);
	NT_GPIOB->OUTENSET_b.OUTENSET |= (1 << 8);
	//  NT_GPIOC->ALTFUNCCLR_b.ALTFUNCCLR = (1 << 2);  NT_GPIOC->OUTENSET_b.OUTENSET |= (1 << 2); ,
	//         :  2-  (   )  ?
	//  ,           ,
	//  "1"   ,   ,     .
	//  ALTFUNCCLR = (1 << 2)        "1"   .
	//   ,     OUTENSET  ALTFUNCCLR "1"      
	//      , . !   "1"  OUTENSET  
	//  ,   ALTFUNCCLR -  . .  :
	//NT_GPIOC->OUTENSET_b.OUTENSET |= (1 << 7);
	//0000 1100 0000 1111			 :       0-3  10-11
	//0000 1100 0000 1111			  
	//0000 1100 1000 1111			 "1"  7- 
	//0000 1100 1000 1111			  
	//0000 1100 1000 1111			:   ,      + 7-,   
	//NT_GPIOC->ALTFUNCCLR_b.ALTFUNCCLR |= (1 << 7);
	//0000 1100 1000 1111			 :    .   0-3, 7  10-11
	//0000 1100 1000 1111			  
	//0000 1100 1000 1111			 "1"  7-  (.. .   ,    )
	//0000 1100 1000 1111			  
	//0000 0000 0000 0000			:   , ..   "1"   ,    "1"   ""
	//NT_GPIOC->ALTFUNCCLR_b.ALTFUNCCLR = (1 << 7);	   ,   "1"   7-   "0" -   :
	//0000 1100 1000 1111			 :    .   0-3, 7  10-11
	//0000 1100 1000 1111			  
	//0000 0000 1000 0000			 "1"  7-   "0"  
	//0000 0000 1000 0000			  
	//0000 1100 0000 1111			:    ,   
	//         SET  CLR.  - .   , 
	//    .
}


//  
void LED_blink (void)
{
	static int timer;	// 
	static int LEDs;	//  

	
	if (timer > TimerPeriod)
	{
		timer = 0;
		LEDs++;
		LEDs &= 0x3F;

		// 1
		if (LEDs & (1<<5))
			VD1_ON;
		else
			VD1_OFF;

		if (LEDs & (1<<4))
			VD2_ON;
		else
			VD2_OFF;

		if (LEDs & (1<<3))
			VD3_ON;
		else
			VD3_OFF;

		if (LEDs & (1<<2))
			VD4_ON;
		else
			VD4_OFF;

		if (LEDs & (1<<1))
			VD5_ON;
		else
			VD5_OFF;

		if (LEDs & (1<<0))
			VD6_ON;
		else
			VD6_OFF;

		// 2 (   ,        -O3)
		//  ,      DATA     ,
		//     .        
		// ,  ,    .
		/*if (LEDs > 31)
		{
			NT_GPIOC->DATA &= ~(1 << 2);
			NT_GPIOC->DATA &= ~(1 << 3);
			NT_GPIOB->DATA &= ~(1 << 5);
			NT_GPIOB->DATA &= ~(1 << 6);
			NT_GPIOB->DATA &= ~(1 << 7);
			NT_GPIOB->DATA &= ~(1 << 8);
		}
		else
		{
			NT_GPIOC->DATA |= (1 << 2);
			NT_GPIOC->DATA |= (1 << 3);
			NT_GPIOB->DATA |= (1 << 5);
			NT_GPIOB->DATA |= (1 << 6);
			NT_GPIOB->DATA |= (1 << 7);
			NT_GPIOB->DATA |= (1 << 8);
		}*/
	}

	timer++;
}


int main (void){
	// :  ,   
	InitCLK();

	//    
	LED_init();

	// 
	while(1)
	{
		LED_blink();	// 
	}
}

/*@}*/

